import React, { useRef, useMemo, useEffect, useState, useContext, createContext } from 'react'
import { ConfigProvider, message } from 'antd'
import Generator from 'fr-generator'
import { settings, baseSettings, globalSettings } from './config'
import widgets from '../widgets'

export const GlobalStore = createContext(null)

const FormDesigner = (props) => {

  const { tableName } = props

  const { getPrefixCls } = useContext(ConfigProvider.ConfigContext)
  const prefixCls = getPrefixCls('pandaXform')
  const pandaXform = getPrefixCls()

  const [table, setTable] = useState()
  const ref = useRef(null)

  const getTableField = () => {

  }

  const getTableInfo = () => {

  }

  const getTable = () => {

  }

  useEffect(() => {
    if (tableName) {
      getTable()
    }
  }, [tableName])

  const extraButtons = [
    {
      text: '提交',
      onClick: (value) => {
        const errors = ref.current.getErrorFields()
        if (errors.length) {
          return message.error('请按照提示完善表单内容')
        }
        console.log('ref.current', ref.current)
        props.setSchema && props.setSchema(ref.current.getValue())
      }
    }
  ]

  const getId = (value) => {
    // console.log('value', value)
    return value
  }

  const onChange = (value) => {
    // console.log('value', value)
  }

  const onSchemaChange = (value) => {
    // console.log('value', value)
    return value
  }

  const onCanvasSelect = (schema) => {
    // setWidget(schema.widget)
    // console.log('value', value)
  }

  return (
    <GlobalStore.Provider
      value={{}}
    >
      <div className={prefixCls}>
        <Generator
          configProvider={{ prefixCls: pandaXform }}
          mapping={{
            object: 'Header',
          }}
          validation={true}
          ref={ref}
          extraButtons={extraButtons}
          onChange={onChange}
          onSchemaChange={onSchemaChange}
          widgets={widgets}
          onCanvasSelect={onCanvasSelect}
          settings={settings}
          commonSettings={baseSettings}
          globalSettings={globalSettings}
        />
      </div>
    </GlobalStore.Provider>
  )

}

export default FormDesigner