import React, { useState, useEffect, useRef, useContext, createContext, forwardRef, useImperativeHandle, useMemo } from 'react'
import FormRender, { useForm } from 'form-render'
import { ConfigProvider } from 'antd'
import widgets from '../widgets'

export const GlobalStore = createContext(null)

const XRender = (props, ref) => {

  // useImperativeHandle(ref, () => ({
  //   form,
  //   getFormValues,
  //   setListData
  // }))

  const { schema } = props

  const { getPrefixCls } = useContext(ConfigProvider.ConfigContext)
  const prefixCls = getPrefixCls('pandaXform')
  const pandaXform = getPrefixCls()

  const [extraData, setExtraData] = useState({})
  const [parseFormData, setParseFormData] = useState({})
  const [listData, setListData] = useState([])
  const form = useForm()

  const onClick = () => {
    console.log('form', form)
  }

  return (
    <GlobalStore.Provider
      value={{
        extraData,
        setExtraData,
        parseFormData,
        setParseFormData,
        listData,
        setParseFormData,
      }}>
      <div className={prefixCls} onClick={() => onClick()}>
        <FormRender
          configProvider={{ prefixCls: pandaXform }}
          form={form}
          schema={schema}
          // onChange={form.setValues}
          mapping={{
            object: 'Header',
          }}
          widgets={widgets}
        />
      </div>
    </GlobalStore.Provider>
  );
}


export default forwardRef(XRender)
