// 选择器，值选择器
import React, { useState, useMemo } from 'react'
import { Select, Checkbox, Radio } from 'antd'
import styels from './index.less'

const { Option } = Select

const ValueSelect = ({ value, onChange, schema }) => {

  const { placeholder, disabled, options, presetValue, showType, isMultiple, isEdit } = schema

  console.log('options', options)

  const valueShow = useMemo(() => {
    if (isMultiple) {
      return (value || presetValue) ? (value || presetValue).split(',') : []
    } else {
      return value || presetValue || null
    }
  }, [presetValue, value])

  const enums = useMemo(() => {

    return Array.isArray(options) ? options.map(v => v.value) : []
    // if (options) {
    //   return options.split(',')
    // }
  }, [options])

  const handleChange = value => {
    if (isEdit) {

    } else {
      if (isMultiple) {
        onChange(value.join(','))
      } else {
        onChange(value)
      }
    }
  }

  // console.log('valueShow', valueShow, disabled)

  if (showType === '下拉') {
    return (
      <Select
        style={{ width: '100%' }}
        mode={isMultiple ? 'multiple' : ''}
        disabled={disabled}
        showArrow={!disabled}
        // optionFilterProp="children"
        value={valueShow}
        placeholder={placeholder}
        onChange={handleChange}
      >
        {enums.map(v => <Option value={v} key={v}>{v}</Option>)}
      </Select>
    )
  }

  if (showType === '平铺') {
    return (
      <div className={styels.tileSelect} type={disabled ? 'disabled' : ''}>
        {
          isMultiple ?
            <Checkbox.Group
              disabled={disabled}
              onChange={value => onChange(value.join(','))}
              value={valueShow}
            >
              {enums.map(v => <Checkbox key={v} value={v}>{v}</Checkbox>)}
            </Checkbox.Group>
            :
            <Radio.Group onChange={e => onChange(e.target.value)} value={valueShow} disabled={disabled}>
              {enums.map(v => <Radio key={v} value={v}>{v}</Radio>)}
            </Radio.Group>
        }
      </div>
    )
  }

  return null

}

export default ValueSelect
