import React, { useState, useEffect, useMemo } from 'react'
import { Input } from 'antd'

const TextArea = ({ value, onChange, schema }) => {

  console.log('多行文本', schema)

  const { disabled, placeholder, presetValue } = schema

  const valueShow = useMemo(() => {
    return presetValue || value
  }, [presetValue, value])

  const handleChange = (e) => {
    onChange(e.target.value)
  }


  return (
    <Input.TextArea
      disabled={disabled}
      value={valueShow}
      rows={5}
      placeholder={placeholder}
      onChange={handleChange}
    />
  )
}

export default TextArea
