import React, { useState, useEffect, useMemo } from 'react'
import { Input } from 'antd'
import Icon, { EllipsisOutlined } from '@ant-design/icons'
import * as icons from '@ant-design/icons'

const iconList = Object.keys(icons).filter((item) => typeof icons[item] === 'object')

const TextInput = (props) => {

  const { value, onChange, schema } = props
  const { disabled, placeholder, presetValue, prefix, suffix, maxLength, rules } = schema

  const valueShow = useMemo(() => {
    return presetValue || value
  }, [presetValue, value])

  const handleChange = (e) => {
    onChange(e.target.value)
  }

  console.log('rules', rules)

  return (
    <Input
      rules={rules}
      disabled={disabled}
      value={valueShow}
      maxLength={maxLength}
      placeholder={disabled ? null : placeholder}
      onChange={handleChange}
      addonBefore={iconList.includes(prefix) ? <Icon component={icons[prefix]} /> : prefix}
      addonAfter={iconList.includes(suffix) ? <Icon component={icons[suffix]} /> : suffix}
    />
  )

}

export default TextInput
